=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,pgpsigurlmangle=s/$/.sig/" \
  https://www.dynare.org/release/source/ dynare-(.*)\.tar\.xz
