## dynare 4.6.1

=== debian/changelog ===
dynare (4.6.1-2) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/u/metadata: Drop Name and Contact fields

  [ Sébastien Villemot ]
  * Various improvements to d/upstream/metadata
  * Bump to debhelper 13
  * sphinx3.patch: new patch, fixes FTBFS against Sphinx 3.1 (Closes: #963646)
  * Ship /usr/lib/dynare/dynare++/dynare_simul.m
  * Add /usr/bin/dynare_m to debian/not-installed.
    Upstream does not really intend to make it a system-wide executable.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Aug 2020 16:10:32 +0200

dynare (4.6.1-1) unstable; urgency=medium

  * New upstream version 4.6.1
  * d/copyright, d/watch: drop provisions for removing embedded MathJax
  * Drop elisp-fixes.patch and missing-clean.patch, no longer needed
  * d/rules: use upstream version number for dh_elpa package version

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 13 Mar 2020 15:23:42 +0100
