## dynare 4.6.2

=== debian/changelog ===
dynare (4.6.2-1) unstable; urgency=medium

  * New upstream version 4.6.2
  * sphinx3.patch: drop patch, applied upstream

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 07 Sep 2020 17:20:36 +0200
