=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
 
 include /usr/share/octave/debian/defs.make
+
+# The following is used by dh_elpa(1) for determining the package version number
+include /usr/share/dpkg/pkg-info.mk
+export DEB_VERSION_UPSTREAM
 
 %:
 	dh $@ --with sphinxdoc,elpa
