=== debian/changelog ===
dynare (4.6.3-4) unstable; urgency=medium

  * octave6.patch: new patch, various compatibility fixes for octave 6

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 08 Jan 2021 12:50:45 +0100

dynare (4.6.3-3) unstable; urgency=medium

  * Add epstool to autopkgtest dependencies, needed since octave 6

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 10 Dec 2020 22:22:05 +0100

dynare (4.6.3-2) unstable; urgency=medium

  * texlive-20201203.patch: new patch, fixes FTBFS against
    texlive-base ≥ 20201203 (Closes: #976501)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 08 Dec 2020 16:25:34 +0100

dynare (4.6.3-1) unstable; urgency=medium

  * New upstream version 4.6.3
  * Bump S-V to 4.5.1
  * Make generated PDFs reproducible.
    Thanks to Vagrant Cascadian (Closes: #974957)
  * Remove auto-generated files which cause reproducibility issues.
    Thanks to Vagrant Cascadian (Closes: #974959)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 25 Nov 2020 09:44:32 +0100
