=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
                python3-sphinx,
                latexmk,
                libjs-mathjax
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/dynare
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/dynare.git
 Homepage: https://www.dynare.org/
