=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,9 @@
 # The following is used by dh_elpa(1) for determining the package version number
 include /usr/share/dpkg/pkg-info.mk
 export DEB_VERSION_UPSTREAM
+
+# Needed for texlive to respect SOURCE_DATE_EPOCH when setting date (#974957)
+export FORCE_SOURCE_DATE=1
 
 %:
 	dh $@ --with sphinxdoc,elpa
@@ -28,6 +31,12 @@
 execute_before_dh_auto_clean:
 	-[ -f Makefile ] && echo -e "distclean:\n\t-rm -f Makefile" > mex/build/matlab/Makefile
 
+execute_after_dh_install:
+	# Remove auto-generated files which cause reproducibility
+	# issues and need to be regenerated to use. (#974959)
+	rm -f debian/dynare-matlab/usr/src/matlab/dynare-matlab/mex/sources/Makefile
+	rm -rf debian/dynare-matlab/usr/src/matlab/dynare-matlab/mex/build/matlab/autom4te.cache/
+
 execute_after_dh_installdocs-indep:
 	cp -dR doc/manual/build/html/ debian/dynare-doc/usr/share/doc/dynare/dynare.html
